#include <stdio.h>
#include <stdlib.h>
#include <math.h>

double factorial(int n);
double power(double x, int n);
double approximation_e(int n, double x);

int main(void) {
	int p;
	float x;
	int i;

	/* Read n */
	do {
		printf("Enter precision (>0): ");
		scanf("%i", &p);
		printf("Enter x: ");
		scanf("%f", &x);
	} while(p <= 0);

	/* Calculate approximation for i={1, 2, 3, ..., p} */
	for(i=1; i<=p; i++) {
		printf("%4i %3.5f %3.5f \n", i, approximation_e(i, x), exp(x));
	}

	/* End program */
	return 0;
}

double approximation_e(int n, double x) {
	double r = 0;
	int k;

	for(k=0; k<=n; k++)
		r += power(x, k) / factorial(k);

	return r;
}

double power(double x, int n) {
	double r = 1;
	int i;

	for(i=1; i<=n; i++)
		r *= x;

	return r;
}

double factorial(int n) {
	int i;
	double f = 1;

	for(i=2; i<=n; i++)
		f *= i;

	return f;
}

