#include <stdio.h>

#define ROWS 2
#define COLS 3

void readMatrix(float m[ROWS][COLS]);
void printMatrix(float m[ROWS][COLS]);
float maxMatrix(float m[ROWS][COLS]);
float minMatrix(float m[ROWS][COLS]);
void add(float m1[ROWS][COLS], float m2[ROWS][COLS], float r[ROWS][COLS]);
void subtract(float m1[ROWS][COLS], float m2[ROWS][COLS], float r[ROWS][COLS]);
void scalarMultiplication(float m[ROWS][COLS], float x, float r[ROWS][COLS]);
void multiplication(float m1[ROWS][COLS], float m2[COLS][ROWS], float r[ROWS][ROWS]);
void transpose(float m[ROWS][COLS], float r[COLS][ROWS]);

int main(void) {
	float a[ROWS][COLS];
	float b[ROWS][COLS];
	float c[ROWS][COLS];
	float p[ROWS][ROWS];
	float t[COLS][ROWS];

	int i, j;

	/* Test functions */
	printf("\nRead matrix a:\n");
	readMatrix(a);
	printf("\nRead matrix b:\n");
	readMatrix(b);

	printf("\nMatrix a:\n");
	printMatrix(a);
	printf("\nMatrix b:\n");
	printMatrix(b);

	printf("\nMax a: %f\n", maxMatrix(a));
	printf("\nMin a: %f\n", minMatrix(a));

	add(a, b, c);
	printf("\nAddition a+b\n");
	printMatrix(c);

	subtract(a, b, c);
	printf("\nSubtraction a-b\n");
	printMatrix(c);

	scalarMultiplication(a, 2.0, c);
	printf("\nMultiplication a*2.0\n");
	printMatrix(c);

	transpose(a, t);
	printf("\nTranspose\n");
	for(i=0; i<COLS; i++) {
		for(j=0; j<ROWS; j++)
			printf("%2.2f ", t[i][j]);
		printf("\n");
	}

	multiplication(a, t, p);
	printf("\nMultiplication a x b\n");
	for(i=0; i<ROWS; i++) {
		for(j=0; j<ROWS; j++)
			printf("%2.2f ", p[i][j]);
		printf("\n");
	}

	return 0;
}

void readMatrix(float m[ROWS][COLS]) {
	int i, j;

	for(i=0; i<ROWS; i++)
		for(j=0; j<COLS; j++) {
			printf("Introduzca valor (%i, %i): ", i, j);
			scanf("%f", &m[i][j]);
		}
	return;
}

void printMatrix(float m[ROWS][COLS]) {
	int i, j;

	for(i=0; i<ROWS; i++) {
		for(j=0; j<COLS; j++) {
			printf("%2.2f ", m[i][j]);
		}
		printf("\n");
	}
	
	return;
}

float maxMatrix(float m[ROWS][COLS]) {
	int i, j;
	float max = m[0][0];

	for(i=0; i<ROWS; i++) {
		for(j=0; j<COLS; j++) {
			if(m[i][j] > max)
				max = m[i][j];
		}
	}

	return max;
}

float minMatrix(float m[ROWS][COLS]) {
	int i, j;
	float min = m[0][0];

	for(i=0; i<ROWS; i++) {
		for(j=0; j<COLS; j++) {
			if(m[i][j] < min)
				min = m[i][j];
		}
	}

	return min;
}

void add(float m1[ROWS][COLS], float m2[ROWS][COLS], float r[ROWS][COLS]) {
	int i, j;

	for(i=0; i<ROWS; i++) {
		for(j=0; j<COLS; j++) {
			r[i][j] = m1[i][j] + m2[i][j];
		}
	}
	
	return;
}

void subtract(float m1[ROWS][COLS], float m2[ROWS][COLS], float r[ROWS][COLS]) {
	int i, j;

	for(i=0; i<ROWS; i++) {
		for(j=0; j<COLS; j++) {
			r[i][j] = m1[i][j] - m2[i][j];
		}
	}
	
	return;
}

void scalarMultiplication(float m[ROWS][COLS], float x, float r[ROWS][COLS]) {
	int i, j;

	for(i=0; i<ROWS; i++) {
		for(j=0; j<COLS; j++) {
			r[i][j] = m[i][j] * x;
		}
	}
	
	return;
}

void multiplication(float m1[ROWS][COLS], float m2[COLS][ROWS], float r[ROWS][ROWS]) {
	int i, j, k;

	for(i=0; i<ROWS; i++)
		for(j=0; j<ROWS; j++) {
			r[i][j] = 0;
			for(k=0; k<COLS; k++)
				r[i][j] += m1[i][k] * m2[k][j];
		}
		
	return;
}

void transpose(float m[ROWS][COLS], float r[COLS][ROWS]) {
	int i, j;

	for(i=0; i<ROWS; i++) {
		for(j=0; j<COLS; j++) {
			r[j][i] = m[i][j];
		}
	}
	
	return;
}
