#include <stdio.h>

struct Fraction {
    int n;      /* Numerator */
    int d;      /* Denominator */
};

struct Fraction addition(struct Fraction x, struct Fraction y);
struct Fraction multiplication(struct Fraction x, struct Fraction y);
struct Fraction division(struct Fraction x, struct Fraction y);
struct Fraction opposite(struct Fraction x);
struct Fraction reciprocal(struct Fraction x);

void printFraction(struct Fraction x);
void initFraction(struct Fraction *x, int num, int den);
float numericalValue(struct Fraction x);
void readFraction(struct Fraction *x);

int main(void) {
    struct Fraction a, b;
    struct Fraction result;
    int exit = 0, choice;

    do {
        printf("\n\nEnter option: ");
        printf("\n1. Add: ");
        printf("\n2. Multiplication: ");
        printf("\n3. Division: ");
        printf("\n4. Reciprocal: ");
        printf("\n5. Opposite: ");
        printf("\n6. End: ");
        printf("\n? ");
        scanf("%i", &choice);

        switch(choice) {
            case 1:
                printf("\nSelected addition.");
                printf("\nFraction 1: \n");
                readFraction(&a);
                printf("\nFraction 2: \n");
                readFraction(&b);
                result = addition(a, b);
                printf("\nResult: ");
                printFraction(result);
                printf("\n(%f) <--> (%f)", numericalValue(result), numericalValue(a) + numericalValue(b) );
                break;

            case 2:
                printf("\nSelected multiplication.");
                printf("\nFraction 1: \n");
                readFraction(&a);
                printf("\nFraction 2: \n");
                readFraction(&b);
                result = multiplication(a, b);
                printf("\nResult: ");
                printFraction(result);
                printf("\n(%f) <--> (%f)", numericalValue(result), numericalValue(a) * numericalValue(b) );
                break;

            case 3:
                printf("\nSelected division.");
                printf("\nFraction 1: \n");
                readFraction(&a);
                printf("\nFraction 2: \n");
                readFraction(&b);
                result = division(a, b);
                printf("\nResult: ");
                printFraction(result);
                printf("\n(%f) <--> (%f)", numericalValue(result), numericalValue(a) / numericalValue(b) );
                break;

            case 4:
                printf("\nSelected reciprocal.");
                printf("\nFraction: \n");
                readFraction(&a);
                result = reciprocal(a);
                printf("\nResult: ");
                printFraction(result);
                break;

            case 5:
                printf("\nSelected opposite.");
                printf("\nFraction: \n");
                readFraction(&a);
                result = opposite(a);
                printf("\nResult: ");
                printFraction(result);
                break;

            case 6:
                exit = 1;
        }

    } while(!exit);

    return 0;
}

struct Fraction addition(struct Fraction x, struct Fraction y) {
    struct Fraction r;

    r.d = x.d * y.d;
    r.n = (r.d / x.d) * x.n + (r.d / y.d) * y.n;

    return r;
}

struct Fraction multiplication(struct Fraction x, struct Fraction y) {
    struct Fraction r;

    r.d = x.d * y.d;
    r.n = x.n * y.n;

    return r;
}

struct Fraction division(struct Fraction x, struct Fraction y) {
    struct Fraction r;

    /* Alternative 1
    r.d = x.d * y.n;
    r.n = x.n * y.d;
    */

    /* Alternative 2 */
    r = multiplication(x, reciprocal(y));

    return r;
}

struct Fraction opposite(struct Fraction x) {
    struct Fraction r;
    r.n = -(x.d - x.n);
    r.d = x.d;
    return r;
}

struct Fraction reciprocal(struct Fraction x) {
    struct Fraction r;
    r.d = x.n;
    r.n = x.d;
    return r;
}


/* Additional methods */
void readFraction(struct Fraction *x) {
    printf("numerator? ");
    scanf("%i", &x->n);
    printf("denominator? ");
    scanf("%i", &x->d);
    return;
}
void printFraction(struct Fraction x) {
    printf("(%i/%i)", x.n, x.d);
    return;
}
void initFraction(struct Fraction *x, int num, int den) {
    x->n = num;
    x->d = den;
    return;
}
float numericalValue(struct Fraction x) {
    return (x.n / (float) x.d);
}

