#include <stdio.h>

void readPrice(int *p);
void initializeChange(int change[8]);
int calculateCoinsOfValue(const int value, int amount);
void printResults(const int cv[8], const int ch[8]);

int main(void) {

	int coinValue[8] = {1, 2, 5, 25, 50, 100, 200, 500};  /* Values of the coins */
	int change[8];  /* Number of coins of each type to give back */
	int toChange;
	int i;

	/* Read price */
	readPrice(&toChange);

	/* Initialize change */
	initializeChange(change);

   /* Calculate coins 
      while the amount to change is > 0 and there are coins
         try with coinValue[i]
         obtain the number of coins with coinValue[i] that will be returned
         if any, decrement the amount to change
         proceed to the next coinValue  */
	i = 7;

	while(toChange>0 && i>=0) {
		int currentValue;
		int coins;

		currentValue = coinValue[i];
		coins = calculateCoinsOfValue(currentValue, toChange);

		if(coins > 0) {
			change[i] = coins;
			toChange -= coins*currentValue;
		}

		i--;
	}

	/* Print results */
	printResults(coinValue, change);

	return 0;

}

void readPrice(int *p) {
	int price, payment;
	printf("Enter price: ");
	scanf("%i", &price);
	printf("Enter payment: ");
	scanf("%i", &payment);

	*p = payment - price;

	return;
}

void initializeChange(int ch[8]) {
	int i;
	for(i=0; i<8; i++)
		ch[i] = 0;

	return;
}

int calculateCoinsOfValue(const int value, int amount) {
	int numberOfCoins = 0;

   /* Decrement as many times as possible 'amount' with 'value'
      The number of possible decrements is the number of coins of 
      this value that should be returned */
      
	while(amount > 0) {
		amount -= value;

		if(amount >= 0)
			numberOfCoins++;
	}

	return numberOfCoins;
}

void printResults(const int cv[8], const int ch[8]) {
	int i=0;

	printf("\nChange: \n");
	for(i=0; i<8; i++) {
		printf("%i coins of %i\n", ch[i], cv[i]);
	}

	return;
}

