#include <stdio.h>

void readPrice(int *p);
void initializeChange(int change[8]);
int calculateCoinsOfValue(const int value, int amount, int available);
void printResults(const int cv[8], const int ch[8]);
void printRemaining(const int cv[8], const int remaining[8]);

int main(void) {

	int coinValue[8]     = {1, 2, 5, 25, 50, 100, 200, 500};  /* Values of the coins */
	int coinAvailable[8] = {0, 1, 1, 1,   1,   1,   1,   1};  /* Number of available coins of each type */
	int change[8];  /* Number of coins of each type returned */
	int toChange;
	int i;

	/* Read price */
	readPrice(&toChange);

	/* Initialize change */
	initializeChange(change);

	/* Calculate coins 
      Similar to Exercise13, but restricting the number of available
      coins in another array coinAvailable */
	i = 7;

	while(toChange>0 && i>=0) {
		int currentValue, currentAvailable;
		int coins;

		currentValue = coinValue[i];
		currentAvailable = coinAvailable[i];
		coins = calculateCoinsOfValue(currentValue, toChange, currentAvailable);

		if(coins > 0) {
			change[i] = coins;
			toChange -= coins*currentValue;
			coinAvailable[i] -= coins;
		}

		i--;
	}

	/* Print results */
	if(toChange != 0) {
		printf("\nNot enough coins to return change.");
		printf("\nApproximate change...");
	}
	printResults(coinValue, change);
	printRemaining(coinValue, coinAvailable);

	return 0;
}

void readPrice(int *p) {
	int price, payment;
	printf("Enter price: ");
	scanf("%i", &price);
	printf("Enter payment: ");
	scanf("%i", &payment);

	*p = payment - price;

	return;
}

void initializeChange(int ch[8]) {
	int i;
	for(i=0; i<8; i++)
		ch[i] = 0;
		
	return;
}

int calculateCoinsOfValue(const int value, int amount, int available) {
	int numberOfCoins = 0;

   /* Similar to Exercise13, but we need to take into account that
      there is a fixed amount of available coins --> decrement
      as many times as possible, but no more than the number of 
      available coins */
      
	while(amount > 0 && available > 0) {
		amount -= value;

		if(amount >= 0) {
			numberOfCoins++;
			available--;
		}
	}

	return numberOfCoins;
}

void printResults(const int cv[8], const int ch[8]) {
	int i=0;

	printf("\nChange: \n");
	for(i=0; i<8; i++) {
		if(ch[i] > 0)
			printf("%i coins of %i\n", ch[i], cv[i]);
	}
}

void printRemaining(const int cv[8], const int remaining[8]) {
	int i=0;

	printf("\nRemaining coins: \n");
	for(i=0; i<8; i++) {
		printf("%i coins of %i\n", remaining[i], cv[i]);
	}
	
	return;
}

